routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('welcome');
//});
Route::group(['prefix'=>'admin', 'namespace'=>'Admin' ],function(){
    // login admin
    Route::get('login','LoginController@showLoginForm')->name('login_admin');
    Route::post('login','LoginController@login')->name('login_admin');
    Route::get('logout', 'LoginController@logOut')->name('logout');
});
Route::group(['prefix'=>'admin','namespace'=>'Admin','middleware' => ['admin']],function(){
    Route::get('/', 'AdminController@home')->name('admin_home');
    // product category
    Route::get('get-child-cate', 'ProductController@getChildCategory')->name('get_child_cate');
    Route::get('create-product', 'ProductController@createProduct')->name('create_product');
    Route::resource('category','CategoryController');
    Route::resource('product','ProductController');
    // create user
    Route::get('create-user','UserController@showCreateUser')->name('create_user');
    Route::post('create-user','UserController@createUser')->name('add_user');
    // orders
    Route::resource('order','OrderController');
    Route::get('list-order','OrderController@anyDatatable')->name('dt_order');
    Route::get('update-status-order','OrderController@updateStatus')->name('update_status_order');
    Route::get('list-items/{id}','OrderController@anyDatatableOrderItem')->name('dt_order_item');
//    Route::get('detail-order','OrderController@detailOrder')->name('dt_order');



});

Route::group(['namespace'=>'Site' ],function(){
    // login site
    Route::get('login-customer','LoginController@showLoginForm')->name('login_customer');
    Route::post('login-customer','LoginController@login')->name('login_customer');
    Route::get('logout', 'LoginController@logOut')->name('logout');
});
Route::group(['namespace'=>'Site'],function(){
    Route::get('/', 'HomeController@index')->name('site_home');
    Route::get('/register-customer', 'CustomerController@register')->name('register');
    Route::resource('customer', 'CustomerController');
    //product ajax
    Route::get('/detail-product', 'ProductController@getDetaiProduct')->name('detail_product');
    Route::post('/addcart-product', 'ProductController@addToCart')->name('add_to_cart');
    //product
    Route::get('product/{slug}', 'ProductController@getDetailProduct')->name('get_detail_product');
    Route::get('category/{slug}', 'ProductController@getProductsCategory')->name('get_category_product');
    Route::post('product/review', 'ProductController@addReview')->name('add_review');

    // cart
    Route::get('/my-cart', 'OrderController@showCart')->name('my_cart');
    Route::get('/remove-item-cart', 'ProductController@removeItemCart')->name('remove_item_cart');
    Route::get('/update-item-cart', 'ProductController@updateItemCart')->name('update_item_cart');
    Route::get('/get-total-price', 'ProductController@getTotalPrice')->name('get_total_price');
    // checkout
    Route::get('/check-out', 'OrderController@showPayMent')->name('check_out');
    Route::post('/check-out', 'OrderController@createOrder')->name('create_order');
    Route::get('/update-cart', 'OrderController@updateCartHeader')->name('update_cart');

});
Auth::routes();

//Route::get('/home', 'HomeController@index')->name('home');

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Entity\Category;
use App\Http\Controllers\Controller;
use App\Ultility\Error;
use App\Ultility\Ultility;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $category = new Category();
        $categories = $category->getCategory();
        return view('admin.categories.add',compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // if slug null slug create as title
        $slug = $this->createSlug($request);
        // insert to database
        $cateId = $this->insertCategory($request, $slug);
        return redirect()->route('category.create');
    }
    protected function createSlug($request) {
        try {
            // if slug null slug create as title
            $slug = $request->input('slug');
            if (empty($slug)) {
                $slug = Ultility::createSlug($request->input('title'));
            }
        } catch (\Exception $e) {
            $slug = rand(10,10000000);

        } finally {
            return $slug;
        }
    }
    private function insertCategory($request, $slug) {
        try {
            $category = new Category();
            $cateId = $category->insertGetId([
                'title' => $request->input('title'),
                'parent' => $request->input('parent'),
                'post_type' => 'product',
                'created_at' => new \DateTime(),
                'updated_at' => new \DateTime(),

            ]);

            // insert slug
            $cateWithSlug = $category->where('slug', $slug)
                ->where('post_type', 'product')
                ->first();
            if (empty($cateWithSlug)) {
                $category->where('category_id', '=', $cateId)
                    ->update([
                        'slug' => $slug
                    ]);
            } else {
                $category->where('category_id', '=', $cateId)
                    ->update([
                        'slug' => $slug.'-'.$cateId
                    ]);
            }

            return $cateId;
        } catch (\Exception $e) {
//            Error::setErrorMessage('Lỗi xảy ra khi thêm mới danh mục: dữ liệu nhập vào không hợp lệ.');
//
//            Log::error('http->admin->CategoryController->insertCategory: Lỗi insert danh mục category');

            return 1;
        }
    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/categories/add.blade.php
@extends('admin.layout.admin')

@section('title', 'Thêm danh mục sản phẩm')

@section('content')

<div class="row">
    <div class="col-md-3">

    </div>
    <div class="col-md-6">
        <!-- general form elements -->
        <div class="card card-primary">
            <div class="card-header">
                <h3 class="card-title">Thêm danh mục</h3>
            </div>
            <!-- /.card-header -->
            <!-- form start -->
            <form role="form" action="{{ route('category.store') }}" method="POST">
                {!! csrf_field() !!}
                {{ method_field('POST') }}
                <div class="card-body">
                    <div class="form-group">
                        <label for="exampleInputEmail1">Tên danh mục</label>
                        <input type="text" class="form-control" id="exampleInputEmail1" placeholder="nhập tên danh mục" name="title">
                    </div>
                    <div class="form-group">
                        <label for="exampleInputEmail1">Danh mục cha</label>
                        <select class="form-control select2 select2-hidden-accessible" style="width: 100%;" data-select2-id="1" tabindex="-1" aria-hidden="true" name="parent">
                            <option selected="selected" data-select2-id="3" value="0">------------------</option>
                            @foreach($categories as $cate)
                                {{print_r($cate)}}
                            <option value="{{$cate->category_id}}">{{$cate->title}}</option>

                            @endforeach

                        </select>
                    </div>
                </div>
                <!-- /.card-body -->

                <div class="card-footer">
                    <button type="submit" class="btn btn-primary">Submit</button>
                </div>
            </form>
        </div>


    </div>
    <div class="col-md-3">

    </div>




</div>
@endsection